/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This file was generated.
 *  with google-apis-code-generator 1.3.0 (build: 2013-04-09 19:13:20 UTC)
 *  on 2013-04-09 at 22:42:56 UTC 
 */

package com.google.api.services.orkut;

import com.google.api.client.googleapis.GoogleUtils;
import com.google.api.client.googleapis.services.AbstractGoogleClientRequest;
import com.google.api.client.googleapis.services.GoogleClientRequestInitializer;
import com.google.api.client.googleapis.services.json.AbstractGoogleJsonClient;
import com.google.api.client.http.HttpRequestInitializer;
import com.google.api.client.http.HttpTransport;
import com.google.api.client.json.JsonFactory;
import com.google.api.client.json.JsonObjectParser;
import com.google.api.client.json.JsonString;
import com.google.common.base.Preconditions;

/**
 * Service definition for Orkut (v2).
 *
 * <p>
 * Lets you manage activities, comments and badges in Orkut. More stuff coming in time.
 * </p>
 *
 * <p>
 * For more information about this service, see the
 * <a href="http://code.google.com/apis/orkut/v2/reference.html" target="_blank">API Documentation</a>
 * </p>
 *
 * <p>
 * This service uses {@link OrkutRequestInitializer} to initialize global parameters via its
 * {@link Builder}.
 * </p>
 *
 * <p>
 * Upgrade warning: this class now extends {@link AbstractGoogleJsonClient}, whereas in prior
 * version 1.8 it extended {@link com.google.api.client.googleapis.services.GoogleClient}.
 * </p>
 *
 * @since 1.3
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public class Orkut extends AbstractGoogleJsonClient {

  // Note: Leave this static initializer at the top of the file.
  static {
    Preconditions.checkState(GoogleUtils.VERSION.equals("1.13.2-beta"),
        "You are currently running with version %s of google-api-client. " +
        "You need version 1.13.2-beta of google-api-client to run version " +
        "1.13.2-beta of the Orkut API library.", GoogleUtils.VERSION);
  }

  /**
   * The default encoded root URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_ROOT_URL = "https://www.googleapis.com/";

  /**
   * The default encoded service path of the service. This is determined when the library is
   * generated and normally should not be changed.
   *
   * @since 1.7
   */
  public static final String DEFAULT_SERVICE_PATH = "orkut/v2/";

  /**
   * The default encoded base URL of the service. This is determined when the library is generated
   * and normally should not be changed.
   * @deprecated (scheduled to be removed in 1.13)
   */
  @Deprecated
  public static final String DEFAULT_BASE_URL = DEFAULT_ROOT_URL + DEFAULT_SERVICE_PATH;

  /**
   * Constructor.
   *
   * <p>
   * Use {@link Builder} if you need to specify any of the optional parameters.
   * </p>
   *
   * @param transport HTTP transport
   * @param jsonFactory JSON factory
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @since 1.7
   */
  public Orkut(HttpTransport transport, JsonFactory jsonFactory,
      HttpRequestInitializer httpRequestInitializer) {
    super(transport,
        jsonFactory,
        DEFAULT_ROOT_URL,
        DEFAULT_SERVICE_PATH,
        httpRequestInitializer,
        false);
  }

  /**
   * @param transport HTTP transport
   * @param httpRequestInitializer HTTP request initializer or {@code null} for none
   * @param rootUrl root URL of the service
   * @param servicePath service path
   * @param jsonObjectParser JSON object parser
   * @param googleClientRequestInitializer Google request initializer or {@code null} for none
   * @param applicationName application name to be sent in the User-Agent header of requests or
   *        {@code null} for none
   * @param suppressPatternChecks whether discovery pattern checks should be suppressed on required
   *        parameters
   */
  Orkut(HttpTransport transport,
      HttpRequestInitializer httpRequestInitializer,
      String rootUrl,
      String servicePath,
      JsonObjectParser jsonObjectParser,
      GoogleClientRequestInitializer googleClientRequestInitializer,
      String applicationName,
      boolean suppressPatternChecks) {
    super(transport,
        httpRequestInitializer,
        rootUrl,
        servicePath,
        jsonObjectParser,
        googleClientRequestInitializer,
        applicationName,
        suppressPatternChecks);
  }

  @Override
  protected void initialize(AbstractGoogleClientRequest<?> httpClientRequest) throws java.io.IOException {
    super.initialize(httpClientRequest);
  }

  /**
   * An accessor for creating requests from the Acl collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.Acl.List request = orkut.acl().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Acl acl() {
    return new Acl();
  }

  /**
   * The "acl" collection of methods.
   */
  public class Acl {

    /**
     * Excludes an element from the ACL of the activity.
     *
     * Create a request for the method "acl.delete".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Delete#execute()} method to invoke the remote operation.
     *
     * @param activityId ID of the activity.
     * @param userId ID of the user to be removed from the activity.
     * @return the request
     */
    public Delete delete(String activityId, String userId) throws java.io.IOException {
      Delete result = new Delete(activityId, userId);
      initialize(result);
      return result;
    }

    public class Delete extends OrkutRequest<Void> {

      private static final String REST_PATH = "activities/{activityId}/acl/{userId}";

      /**
       * Excludes an element from the ACL of the activity.
       *
       * Create a request for the method "acl.delete".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Delete#execute()} method to invoke the remote operation. <p> {@link
       * Delete#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param activityId ID of the activity.
       * @param userId ID of the user to be removed from the activity.
       * @since 1.13
       */
      protected Delete(String activityId, String userId) {
        super(Orkut.this, "DELETE", REST_PATH, null, Void.class);
        this.activityId = Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public Delete setAlt(String alt) {
        return (Delete) super.setAlt(alt);
      }

      @Override
      public Delete setFields(String fields) {
        return (Delete) super.setFields(fields);
      }

      @Override
      public Delete setKey(String key) {
        return (Delete) super.setKey(key);
      }

      @Override
      public Delete setOauthToken(String oauthToken) {
        return (Delete) super.setOauthToken(oauthToken);
      }

      @Override
      public Delete setPrettyPrint(Boolean prettyPrint) {
        return (Delete) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Delete setQuotaUser(String quotaUser) {
        return (Delete) super.setQuotaUser(quotaUser);
      }

      @Override
      public Delete setUserIp(String userIp) {
        return (Delete) super.setUserIp(userIp);
      }

      /** ID of the activity. */
      @com.google.api.client.util.Key
      private String activityId;

      /** ID of the activity.
       */
      public String getActivityId() {
        return activityId;
      }

      /** ID of the activity. */
      public Delete setActivityId(String activityId) {
        this.activityId = activityId;
        return this;
      }

      /** ID of the user to be removed from the activity. */
      @com.google.api.client.util.Key
      private String userId;

      /** ID of the user to be removed from the activity.
       */
      public String getUserId() {
        return userId;
      }

      /** ID of the user to be removed from the activity. */
      public Delete setUserId(String userId) {
        this.userId = userId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Activities collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.Activities.List request = orkut.activities().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Activities activities() {
    return new Activities();
  }

  /**
   * The "activities" collection of methods.
   */
  public class Activities {

    /**
     * Deletes an existing activity, if the access controls allow it.
     *
     * Create a request for the method "activities.delete".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Delete#execute()} method to invoke the remote operation.
     *
     * @param activityId ID of the activity to remove.
     * @return the request
     */
    public Delete delete(String activityId) throws java.io.IOException {
      Delete result = new Delete(activityId);
      initialize(result);
      return result;
    }

    public class Delete extends OrkutRequest<Void> {

      private static final String REST_PATH = "activities/{activityId}";

      /**
       * Deletes an existing activity, if the access controls allow it.
       *
       * Create a request for the method "activities.delete".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Delete#execute()} method to invoke the remote operation. <p> {@link
       * Delete#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param activityId ID of the activity to remove.
       * @since 1.13
       */
      protected Delete(String activityId) {
        super(Orkut.this, "DELETE", REST_PATH, null, Void.class);
        this.activityId = Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public Delete setAlt(String alt) {
        return (Delete) super.setAlt(alt);
      }

      @Override
      public Delete setFields(String fields) {
        return (Delete) super.setFields(fields);
      }

      @Override
      public Delete setKey(String key) {
        return (Delete) super.setKey(key);
      }

      @Override
      public Delete setOauthToken(String oauthToken) {
        return (Delete) super.setOauthToken(oauthToken);
      }

      @Override
      public Delete setPrettyPrint(Boolean prettyPrint) {
        return (Delete) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Delete setQuotaUser(String quotaUser) {
        return (Delete) super.setQuotaUser(quotaUser);
      }

      @Override
      public Delete setUserIp(String userIp) {
        return (Delete) super.setUserIp(userIp);
      }

      /** ID of the activity to remove. */
      @com.google.api.client.util.Key
      private String activityId;

      /** ID of the activity to remove.
       */
      public String getActivityId() {
        return activityId;
      }

      /** ID of the activity to remove. */
      public Delete setActivityId(String activityId) {
        this.activityId = activityId;
        return this;
      }

    }
    /**
     * Retrieves a list of activities.
     *
     * Create a request for the method "activities.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user whose activities will be listed. Can be me to refer to the viewer (i.e. the
     *        authenticated user).
     * @param collection The collection of activities to list.
     * @return the request
     */
    public List list(String userId, String collection) throws java.io.IOException {
      List result = new List(userId, collection);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.ActivityList> {

      private static final String REST_PATH = "people/{userId}/activities/{collection}";

      /**
       * Retrieves a list of activities.
       *
       * Create a request for the method "activities.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user whose activities will be listed. Can be me to refer to the viewer (i.e. the
     *        authenticated user).
       * @param collection The collection of activities to list.
       * @since 1.13
       */
      protected List(String userId, String collection) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.ActivityList.class);
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
        this.collection = Preconditions.checkNotNull(collection, "Required parameter collection must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /**
     * The ID of the user whose activities will be listed. Can be me to refer to the viewer (i.e.
     * the authenticated user).
     */
      @com.google.api.client.util.Key
      private String userId;

      /** The ID of the user whose activities will be listed. Can be me to refer to the viewer (i.e. the
     authenticated user).
       */
      public String getUserId() {
        return userId;
      }

      /**
     * The ID of the user whose activities will be listed. Can be me to refer to the viewer (i.e.
     * the authenticated user).
     */
      public List setUserId(String userId) {
        this.userId = userId;
        return this;
      }

      /** The collection of activities to list. */
      @com.google.api.client.util.Key
      private String collection;

      /** The collection of activities to list.
       */
      public String getCollection() {
        return collection;
      }

      /** The collection of activities to list. */
      public List setCollection(String collection) {
        this.collection = collection;
        return this;
      }

      /** A continuation token that allows pagination. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token that allows pagination.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** A continuation token that allows pagination. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The maximum number of activities to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of activities to include in the response.

     [minimum: 1] [maximum: 100]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of activities to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the ActivityVisibility collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.ActivityVisibility.List request = orkut.activityVisibility().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public ActivityVisibility activityVisibility() {
    return new ActivityVisibility();
  }

  /**
   * The "activityVisibility" collection of methods.
   */
  public class ActivityVisibility {

    /**
     * Gets the visibility of an existing activity.
     *
     * Create a request for the method "activityVisibility.get".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param activityId ID of the activity to get the visibility.
     * @return the request
     */
    public Get get(String activityId) throws java.io.IOException {
      Get result = new Get(activityId);
      initialize(result);
      return result;
    }

    public class Get extends OrkutRequest<com.google.api.services.orkut.model.Visibility> {

      private static final String REST_PATH = "activities/{activityId}/visibility";

      /**
       * Gets the visibility of an existing activity.
       *
       * Create a request for the method "activityVisibility.get".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param activityId ID of the activity to get the visibility.
       * @since 1.13
       */
      protected Get(String activityId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.Visibility.class);
        this.activityId = Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** ID of the activity to get the visibility. */
      @com.google.api.client.util.Key
      private String activityId;

      /** ID of the activity to get the visibility.
       */
      public String getActivityId() {
        return activityId;
      }

      /** ID of the activity to get the visibility. */
      public Get setActivityId(String activityId) {
        this.activityId = activityId;
        return this;
      }

    }
    /**
     * Updates the visibility of an existing activity. This method supports patch semantics.
     *
     * Create a request for the method "activityVisibility.patch".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Patch#execute()} method to invoke the remote operation.
     *
     * @param activityId ID of the activity.
     * @param content the {@link com.google.api.services.orkut.model.Visibility}
     * @return the request
     */
    public Patch patch(String activityId, com.google.api.services.orkut.model.Visibility content) throws java.io.IOException {
      Patch result = new Patch(activityId, content);
      initialize(result);
      return result;
    }

    public class Patch extends OrkutRequest<com.google.api.services.orkut.model.Visibility> {

      private static final String REST_PATH = "activities/{activityId}/visibility";

      /**
       * Updates the visibility of an existing activity. This method supports patch semantics.
       *
       * Create a request for the method "activityVisibility.patch".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Patch#execute()} method to invoke the remote operation. <p> {@link
       * Patch#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param activityId ID of the activity.
       * @param content the {@link com.google.api.services.orkut.model.Visibility}
       * @since 1.13
       */
      protected Patch(String activityId, com.google.api.services.orkut.model.Visibility content) {
        super(Orkut.this, "PATCH", REST_PATH, content, com.google.api.services.orkut.model.Visibility.class);
        this.activityId = Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public Patch setAlt(String alt) {
        return (Patch) super.setAlt(alt);
      }

      @Override
      public Patch setFields(String fields) {
        return (Patch) super.setFields(fields);
      }

      @Override
      public Patch setKey(String key) {
        return (Patch) super.setKey(key);
      }

      @Override
      public Patch setOauthToken(String oauthToken) {
        return (Patch) super.setOauthToken(oauthToken);
      }

      @Override
      public Patch setPrettyPrint(Boolean prettyPrint) {
        return (Patch) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Patch setQuotaUser(String quotaUser) {
        return (Patch) super.setQuotaUser(quotaUser);
      }

      @Override
      public Patch setUserIp(String userIp) {
        return (Patch) super.setUserIp(userIp);
      }

      /** ID of the activity. */
      @com.google.api.client.util.Key
      private String activityId;

      /** ID of the activity.
       */
      public String getActivityId() {
        return activityId;
      }

      /** ID of the activity. */
      public Patch setActivityId(String activityId) {
        this.activityId = activityId;
        return this;
      }

    }
    /**
     * Updates the visibility of an existing activity.
     *
     * Create a request for the method "activityVisibility.update".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Update#execute()} method to invoke the remote operation.
     *
     * @param activityId ID of the activity.
     * @param content the {@link com.google.api.services.orkut.model.Visibility}
     * @return the request
     */
    public Update update(String activityId, com.google.api.services.orkut.model.Visibility content) throws java.io.IOException {
      Update result = new Update(activityId, content);
      initialize(result);
      return result;
    }

    public class Update extends OrkutRequest<com.google.api.services.orkut.model.Visibility> {

      private static final String REST_PATH = "activities/{activityId}/visibility";

      /**
       * Updates the visibility of an existing activity.
       *
       * Create a request for the method "activityVisibility.update".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Update#execute()} method to invoke the remote operation. <p> {@link
       * Update#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param activityId ID of the activity.
       * @param content the {@link com.google.api.services.orkut.model.Visibility}
       * @since 1.13
       */
      protected Update(String activityId, com.google.api.services.orkut.model.Visibility content) {
        super(Orkut.this, "PUT", REST_PATH, content, com.google.api.services.orkut.model.Visibility.class);
        this.activityId = Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public Update setAlt(String alt) {
        return (Update) super.setAlt(alt);
      }

      @Override
      public Update setFields(String fields) {
        return (Update) super.setFields(fields);
      }

      @Override
      public Update setKey(String key) {
        return (Update) super.setKey(key);
      }

      @Override
      public Update setOauthToken(String oauthToken) {
        return (Update) super.setOauthToken(oauthToken);
      }

      @Override
      public Update setPrettyPrint(Boolean prettyPrint) {
        return (Update) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Update setQuotaUser(String quotaUser) {
        return (Update) super.setQuotaUser(quotaUser);
      }

      @Override
      public Update setUserIp(String userIp) {
        return (Update) super.setUserIp(userIp);
      }

      /** ID of the activity. */
      @com.google.api.client.util.Key
      private String activityId;

      /** ID of the activity.
       */
      public String getActivityId() {
        return activityId;
      }

      /** ID of the activity. */
      public Update setActivityId(String activityId) {
        this.activityId = activityId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Badges collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.Badges.List request = orkut.badges().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Badges badges() {
    return new Badges();
  }

  /**
   * The "badges" collection of methods.
   */
  public class Badges {

    /**
     * Retrieves a badge from a user.
     *
     * Create a request for the method "badges.get".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user whose badges will be listed. Can be me to refer to caller.
     * @param badgeId The ID of the badge that will be retrieved.
     * @return the request
     */
    public Get get(String userId, Long badgeId) throws java.io.IOException {
      Get result = new Get(userId, badgeId);
      initialize(result);
      return result;
    }

    public class Get extends OrkutRequest<com.google.api.services.orkut.model.Badge> {

      private static final String REST_PATH = "people/{userId}/badges/{badgeId}";

      /**
       * Retrieves a badge from a user.
       *
       * Create a request for the method "badges.get".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user whose badges will be listed. Can be me to refer to caller.
       * @param badgeId The ID of the badge that will be retrieved.
       * @since 1.13
       */
      protected Get(String userId, Long badgeId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.Badge.class);
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
        this.badgeId = Preconditions.checkNotNull(badgeId, "Required parameter badgeId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The ID of the user whose badges will be listed. Can be me to refer to caller. */
      @com.google.api.client.util.Key
      private String userId;

      /** The ID of the user whose badges will be listed. Can be me to refer to caller.
       */
      public String getUserId() {
        return userId;
      }

      /** The ID of the user whose badges will be listed. Can be me to refer to caller. */
      public Get setUserId(String userId) {
        this.userId = userId;
        return this;
      }

      /** The ID of the badge that will be retrieved. */
      @com.google.api.client.util.Key
      private Long badgeId;

      /** The ID of the badge that will be retrieved.
       */
      public Long getBadgeId() {
        return badgeId;
      }

      /** The ID of the badge that will be retrieved. */
      public Get setBadgeId(Long badgeId) {
        this.badgeId = badgeId;
        return this;
      }

    }
    /**
     * Retrieves the list of visible badges of a user.
     *
     * Create a request for the method "badges.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId The id of the user whose badges will be listed. Can be me to refer to caller.
     * @return the request
     */
    public List list(String userId) throws java.io.IOException {
      List result = new List(userId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.BadgeList> {

      private static final String REST_PATH = "people/{userId}/badges";

      /**
       * Retrieves the list of visible badges of a user.
       *
       * Create a request for the method "badges.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param userId The id of the user whose badges will be listed. Can be me to refer to caller.
       * @since 1.13
       */
      protected List(String userId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.BadgeList.class);
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The id of the user whose badges will be listed. Can be me to refer to caller. */
      @com.google.api.client.util.Key
      private String userId;

      /** The id of the user whose badges will be listed. Can be me to refer to caller.
       */
      public String getUserId() {
        return userId;
      }

      /** The id of the user whose badges will be listed. Can be me to refer to caller. */
      public List setUserId(String userId) {
        this.userId = userId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Comments collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.Comments.List request = orkut.comments().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Comments comments() {
    return new Comments();
  }

  /**
   * The "comments" collection of methods.
   */
  public class Comments {

    /**
     * Deletes an existing comment.
     *
     * Create a request for the method "comments.delete".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Delete#execute()} method to invoke the remote operation.
     *
     * @param commentId ID of the comment to remove.
     * @return the request
     */
    public Delete delete(String commentId) throws java.io.IOException {
      Delete result = new Delete(commentId);
      initialize(result);
      return result;
    }

    public class Delete extends OrkutRequest<Void> {

      private static final String REST_PATH = "comments/{commentId}";

      /**
       * Deletes an existing comment.
       *
       * Create a request for the method "comments.delete".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Delete#execute()} method to invoke the remote operation. <p> {@link
       * Delete#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param commentId ID of the comment to remove.
       * @since 1.13
       */
      protected Delete(String commentId) {
        super(Orkut.this, "DELETE", REST_PATH, null, Void.class);
        this.commentId = Preconditions.checkNotNull(commentId, "Required parameter commentId must be specified.");
      }

      @Override
      public Delete setAlt(String alt) {
        return (Delete) super.setAlt(alt);
      }

      @Override
      public Delete setFields(String fields) {
        return (Delete) super.setFields(fields);
      }

      @Override
      public Delete setKey(String key) {
        return (Delete) super.setKey(key);
      }

      @Override
      public Delete setOauthToken(String oauthToken) {
        return (Delete) super.setOauthToken(oauthToken);
      }

      @Override
      public Delete setPrettyPrint(Boolean prettyPrint) {
        return (Delete) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Delete setQuotaUser(String quotaUser) {
        return (Delete) super.setQuotaUser(quotaUser);
      }

      @Override
      public Delete setUserIp(String userIp) {
        return (Delete) super.setUserIp(userIp);
      }

      /** ID of the comment to remove. */
      @com.google.api.client.util.Key
      private String commentId;

      /** ID of the comment to remove.
       */
      public String getCommentId() {
        return commentId;
      }

      /** ID of the comment to remove. */
      public Delete setCommentId(String commentId) {
        this.commentId = commentId;
        return this;
      }

    }
    /**
     * Retrieves an existing comment.
     *
     * Create a request for the method "comments.get".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param commentId ID of the comment to get.
     * @return the request
     */
    public Get get(String commentId) throws java.io.IOException {
      Get result = new Get(commentId);
      initialize(result);
      return result;
    }

    public class Get extends OrkutRequest<com.google.api.services.orkut.model.Comment> {

      private static final String REST_PATH = "comments/{commentId}";

      /**
       * Retrieves an existing comment.
       *
       * Create a request for the method "comments.get".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param commentId ID of the comment to get.
       * @since 1.13
       */
      protected Get(String commentId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.Comment.class);
        this.commentId = Preconditions.checkNotNull(commentId, "Required parameter commentId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** ID of the comment to get. */
      @com.google.api.client.util.Key
      private String commentId;

      /** ID of the comment to get.
       */
      public String getCommentId() {
        return commentId;
      }

      /** ID of the comment to get. */
      public Get setCommentId(String commentId) {
        this.commentId = commentId;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public Get setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }
    /**
     * Inserts a new comment to an activity.
     *
     * Create a request for the method "comments.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param activityId The ID of the activity to contain the new comment.
     * @param content the {@link com.google.api.services.orkut.model.Comment}
     * @return the request
     */
    public Insert insert(String activityId, com.google.api.services.orkut.model.Comment content) throws java.io.IOException {
      Insert result = new Insert(activityId, content);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.Comment> {

      private static final String REST_PATH = "activities/{activityId}/comments";

      /**
       * Inserts a new comment to an activity.
       *
       * Create a request for the method "comments.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param activityId The ID of the activity to contain the new comment.
       * @param content the {@link com.google.api.services.orkut.model.Comment}
       * @since 1.13
       */
      protected Insert(String activityId, com.google.api.services.orkut.model.Comment content) {
        super(Orkut.this, "POST", REST_PATH, content, com.google.api.services.orkut.model.Comment.class);
        this.activityId = Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The ID of the activity to contain the new comment. */
      @com.google.api.client.util.Key
      private String activityId;

      /** The ID of the activity to contain the new comment.
       */
      public String getActivityId() {
        return activityId;
      }

      /** The ID of the activity to contain the new comment. */
      public Insert setActivityId(String activityId) {
        this.activityId = activityId;
        return this;
      }

    }
    /**
     * Retrieves a list of comments, possibly filtered.
     *
     * Create a request for the method "comments.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param activityId The ID of the activity containing the comments.
     * @return the request
     */
    public List list(String activityId) throws java.io.IOException {
      List result = new List(activityId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommentList> {

      private static final String REST_PATH = "activities/{activityId}/comments";

      /**
       * Retrieves a list of comments, possibly filtered.
       *
       * Create a request for the method "comments.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param activityId The ID of the activity containing the comments.
       * @since 1.13
       */
      protected List(String activityId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommentList.class);
        this.activityId = Preconditions.checkNotNull(activityId, "Required parameter activityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the activity containing the comments. */
      @com.google.api.client.util.Key
      private String activityId;

      /** The ID of the activity containing the comments.
       */
      public String getActivityId() {
        return activityId;
      }

      /** The ID of the activity containing the comments. */
      public List setActivityId(String activityId) {
        this.activityId = activityId;
        return this;
      }

      /** Sort search results. */
      @com.google.api.client.util.Key
      private String orderBy;

      /** Sort search results. [default: DESCENDING_SORT]
       */
      public String getOrderBy() {
        return orderBy;
      }

      /** Sort search results. */
      public List setOrderBy(String orderBy) {
        this.orderBy = orderBy;
        return this;
      }

      /** A continuation token that allows pagination. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token that allows pagination.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** A continuation token that allows pagination. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The maximum number of activities to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of activities to include in the response.

     [minimum: 1]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of activities to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Communities collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.Communities.List request = orkut.communities().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Communities communities() {
    return new Communities();
  }

  /**
   * The "communities" collection of methods.
   */
  public class Communities {

    /**
     * Retrieves the basic information (aka. profile) of a community.
     *
     * Create a request for the method "communities.get".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community to get.
     * @return the request
     */
    public Get get(Integer communityId) throws java.io.IOException {
      Get result = new Get(communityId);
      initialize(result);
      return result;
    }

    public class Get extends OrkutRequest<com.google.api.services.orkut.model.Community> {

      private static final String REST_PATH = "communities/{communityId}";

      /**
       * Retrieves the basic information (aka. profile) of a community.
       *
       * Create a request for the method "communities.get".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community to get.
       * @since 1.13
       */
      protected Get(Integer communityId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.Community.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The ID of the community to get. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community to get.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community to get. */
      public Get setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public Get setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }
    /**
     * Retrieves the list of communities the current user is a member of.
     *
     * Create a request for the method "communities.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user whose communities will be listed. Can be me to refer to caller.
     * @return the request
     */
    public List list(String userId) throws java.io.IOException {
      List result = new List(userId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommunityList> {

      private static final String REST_PATH = "people/{userId}/communities";

      /**
       * Retrieves the list of communities the current user is a member of.
       *
       * Create a request for the method "communities.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user whose communities will be listed. Can be me to refer to caller.
       * @since 1.13
       */
      protected List(String userId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityList.class);
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the user whose communities will be listed. Can be me to refer to caller. */
      @com.google.api.client.util.Key
      private String userId;

      /** The ID of the user whose communities will be listed. Can be me to refer to caller.
       */
      public String getUserId() {
        return userId;
      }

      /** The ID of the user whose communities will be listed. Can be me to refer to caller. */
      public List setUserId(String userId) {
        this.userId = userId;
        return this;
      }

      /** How to order the communities by. */
      @com.google.api.client.util.Key
      private String orderBy;

      /** How to order the communities by.
       */
      public String getOrderBy() {
        return orderBy;
      }

      /** How to order the communities by. */
      public List setOrderBy(String orderBy) {
        this.orderBy = orderBy;
        return this;
      }

      /** The maximum number of communities to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of communities to include in the response.

     [minimum: 1]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of communities to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityFollow collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityFollow.List request = orkut.communityFollow().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityFollow communityFollow() {
    return new CommunityFollow();
  }

  /**
   * The "communityFollow" collection of methods.
   */
  public class CommunityFollow {

    /**
     * Removes a user from the followers of a community.
     *
     * Create a request for the method "communityFollow.delete".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Delete#execute()} method to invoke the remote operation.
     *
     * @param communityId ID of the community.
     * @param userId ID of the user.
     * @return the request
     */
    public Delete delete(Integer communityId, String userId) throws java.io.IOException {
      Delete result = new Delete(communityId, userId);
      initialize(result);
      return result;
    }

    public class Delete extends OrkutRequest<Void> {

      private static final String REST_PATH = "communities/{communityId}/followers/{userId}";

      /**
       * Removes a user from the followers of a community.
       *
       * Create a request for the method "communityFollow.delete".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Delete#execute()} method to invoke the remote operation. <p> {@link
       * Delete#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId ID of the community.
       * @param userId ID of the user.
       * @since 1.13
       */
      protected Delete(Integer communityId, String userId) {
        super(Orkut.this, "DELETE", REST_PATH, null, Void.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public Delete setAlt(String alt) {
        return (Delete) super.setAlt(alt);
      }

      @Override
      public Delete setFields(String fields) {
        return (Delete) super.setFields(fields);
      }

      @Override
      public Delete setKey(String key) {
        return (Delete) super.setKey(key);
      }

      @Override
      public Delete setOauthToken(String oauthToken) {
        return (Delete) super.setOauthToken(oauthToken);
      }

      @Override
      public Delete setPrettyPrint(Boolean prettyPrint) {
        return (Delete) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Delete setQuotaUser(String quotaUser) {
        return (Delete) super.setQuotaUser(quotaUser);
      }

      @Override
      public Delete setUserIp(String userIp) {
        return (Delete) super.setUserIp(userIp);
      }

      /** ID of the community. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** ID of the community.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** ID of the community. */
      public Delete setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** ID of the user. */
      @com.google.api.client.util.Key
      private String userId;

      /** ID of the user.
       */
      public String getUserId() {
        return userId;
      }

      /** ID of the user. */
      public Delete setUserId(String userId) {
        this.userId = userId;
        return this;
      }

    }
    /**
     * Adds a user as a follower of a community.
     *
     * Create a request for the method "communityFollow.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param communityId ID of the community.
     * @param userId ID of the user.
     * @return the request
     */
    public Insert insert(Integer communityId, String userId) throws java.io.IOException {
      Insert result = new Insert(communityId, userId);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.CommunityMembers> {

      private static final String REST_PATH = "communities/{communityId}/followers/{userId}";

      /**
       * Adds a user as a follower of a community.
       *
       * Create a request for the method "communityFollow.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId ID of the community.
       * @param userId ID of the user.
       * @since 1.13
       */
      protected Insert(Integer communityId, String userId) {
        super(Orkut.this, "POST", REST_PATH, null, com.google.api.services.orkut.model.CommunityMembers.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** ID of the community. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** ID of the community.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** ID of the community. */
      public Insert setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** ID of the user. */
      @com.google.api.client.util.Key
      private String userId;

      /** ID of the user.
       */
      public String getUserId() {
        return userId;
      }

      /** ID of the user. */
      public Insert setUserId(String userId) {
        this.userId = userId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityMembers collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityMembers.List request = orkut.communityMembers().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityMembers communityMembers() {
    return new CommunityMembers();
  }

  /**
   * The "communityMembers" collection of methods.
   */
  public class CommunityMembers {

    /**
     * Makes the user leave a community.
     *
     * Create a request for the method "communityMembers.delete".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Delete#execute()} method to invoke the remote operation.
     *
     * @param communityId ID of the community.
     * @param userId ID of the user.
     * @return the request
     */
    public Delete delete(Integer communityId, String userId) throws java.io.IOException {
      Delete result = new Delete(communityId, userId);
      initialize(result);
      return result;
    }

    public class Delete extends OrkutRequest<Void> {

      private static final String REST_PATH = "communities/{communityId}/members/{userId}";

      /**
       * Makes the user leave a community.
       *
       * Create a request for the method "communityMembers.delete".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Delete#execute()} method to invoke the remote operation. <p> {@link
       * Delete#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId ID of the community.
       * @param userId ID of the user.
       * @since 1.13
       */
      protected Delete(Integer communityId, String userId) {
        super(Orkut.this, "DELETE", REST_PATH, null, Void.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public Delete setAlt(String alt) {
        return (Delete) super.setAlt(alt);
      }

      @Override
      public Delete setFields(String fields) {
        return (Delete) super.setFields(fields);
      }

      @Override
      public Delete setKey(String key) {
        return (Delete) super.setKey(key);
      }

      @Override
      public Delete setOauthToken(String oauthToken) {
        return (Delete) super.setOauthToken(oauthToken);
      }

      @Override
      public Delete setPrettyPrint(Boolean prettyPrint) {
        return (Delete) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Delete setQuotaUser(String quotaUser) {
        return (Delete) super.setQuotaUser(quotaUser);
      }

      @Override
      public Delete setUserIp(String userIp) {
        return (Delete) super.setUserIp(userIp);
      }

      /** ID of the community. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** ID of the community.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** ID of the community. */
      public Delete setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** ID of the user. */
      @com.google.api.client.util.Key
      private String userId;

      /** ID of the user.
       */
      public String getUserId() {
        return userId;
      }

      /** ID of the user. */
      public Delete setUserId(String userId) {
        this.userId = userId;
        return this;
      }

    }
    /**
     * Retrieves the relationship between a user and a community.
     *
     * Create a request for the method "communityMembers.get".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param communityId ID of the community.
     * @param userId ID of the user.
     * @return the request
     */
    public Get get(Integer communityId, String userId) throws java.io.IOException {
      Get result = new Get(communityId, userId);
      initialize(result);
      return result;
    }

    public class Get extends OrkutRequest<com.google.api.services.orkut.model.CommunityMembers> {

      private static final String REST_PATH = "communities/{communityId}/members/{userId}";

      /**
       * Retrieves the relationship between a user and a community.
       *
       * Create a request for the method "communityMembers.get".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId ID of the community.
       * @param userId ID of the user.
       * @since 1.13
       */
      protected Get(Integer communityId, String userId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityMembers.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** ID of the community. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** ID of the community.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** ID of the community. */
      public Get setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** ID of the user. */
      @com.google.api.client.util.Key
      private String userId;

      /** ID of the user.
       */
      public String getUserId() {
        return userId;
      }

      /** ID of the user. */
      public Get setUserId(String userId) {
        this.userId = userId;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public Get setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }
    /**
     * Makes the user join a community.
     *
     * Create a request for the method "communityMembers.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param communityId ID of the community.
     * @param userId ID of the user.
     * @return the request
     */
    public Insert insert(Integer communityId, String userId) throws java.io.IOException {
      Insert result = new Insert(communityId, userId);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.CommunityMembers> {

      private static final String REST_PATH = "communities/{communityId}/members/{userId}";

      /**
       * Makes the user join a community.
       *
       * Create a request for the method "communityMembers.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId ID of the community.
       * @param userId ID of the user.
       * @since 1.13
       */
      protected Insert(Integer communityId, String userId) {
        super(Orkut.this, "POST", REST_PATH, null, com.google.api.services.orkut.model.CommunityMembers.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** ID of the community. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** ID of the community.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** ID of the community. */
      public Insert setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** ID of the user. */
      @com.google.api.client.util.Key
      private String userId;

      /** ID of the user.
       */
      public String getUserId() {
        return userId;
      }

      /** ID of the user. */
      public Insert setUserId(String userId) {
        this.userId = userId;
        return this;
      }

    }
    /**
     * Lists members of a community. Use the pagination tokens to retrieve the full list; do not rely on
     * the member count available in the community profile information to know when to stop iterating,
     * as that count may be approximate.
     *
     * Create a request for the method "communityMembers.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose members will be listed.
     * @return the request
     */
    public List list(Integer communityId) throws java.io.IOException {
      List result = new List(communityId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommunityMembersList> {

      private static final String REST_PATH = "communities/{communityId}/members";

      /**
       * Lists members of a community. Use the pagination tokens to retrieve the full list; do not rely
       * on the member count available in the community profile information to know when to stop
       * iterating, as that count may be approximate.
       *
       * Create a request for the method "communityMembers.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose members will be listed.
       * @since 1.13
       */
      protected List(Integer communityId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityMembersList.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the community whose members will be listed. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose members will be listed.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose members will be listed. */
      public List setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** A continuation token that allows pagination. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token that allows pagination.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** A continuation token that allows pagination. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** Whether to list only community members who are friends of the user. */
      @com.google.api.client.util.Key
      private Boolean friendsOnly;

      /** Whether to list only community members who are friends of the user.
       */
      public Boolean getFriendsOnly() {
        return friendsOnly;
      }

      /** Whether to list only community members who are friends of the user. */
      public List setFriendsOnly(Boolean friendsOnly) {
        this.friendsOnly = friendsOnly;
        return this;
      }

      /** The maximum number of members to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of members to include in the response.

     [minimum: 1]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of members to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityMessages collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityMessages.List request = orkut.communityMessages().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityMessages communityMessages() {
    return new CommunityMessages();
  }

  /**
   * The "communityMessages" collection of methods.
   */
  public class CommunityMessages {

    /**
     * Moves a message of the community to the trash folder.
     *
     * Create a request for the method "communityMessages.delete".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Delete#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose message will be moved to the trash folder.
     * @param topicId The ID of the topic whose message will be moved to the trash folder.
     * @param messageId The ID of the message to be moved to the trash folder.
     * @return the request
     */
    public Delete delete(Integer communityId, Long topicId, Long messageId) throws java.io.IOException {
      Delete result = new Delete(communityId, topicId, messageId);
      initialize(result);
      return result;
    }

    public class Delete extends OrkutRequest<Void> {

      private static final String REST_PATH = "communities/{communityId}/topics/{topicId}/messages/{messageId}";

      /**
       * Moves a message of the community to the trash folder.
       *
       * Create a request for the method "communityMessages.delete".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Delete#execute()} method to invoke the remote operation. <p> {@link
       * Delete#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose message will be moved to the trash folder.
       * @param topicId The ID of the topic whose message will be moved to the trash folder.
       * @param messageId The ID of the message to be moved to the trash folder.
       * @since 1.13
       */
      protected Delete(Integer communityId, Long topicId, Long messageId) {
        super(Orkut.this, "DELETE", REST_PATH, null, Void.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.topicId = Preconditions.checkNotNull(topicId, "Required parameter topicId must be specified.");
        this.messageId = Preconditions.checkNotNull(messageId, "Required parameter messageId must be specified.");
      }

      @Override
      public Delete setAlt(String alt) {
        return (Delete) super.setAlt(alt);
      }

      @Override
      public Delete setFields(String fields) {
        return (Delete) super.setFields(fields);
      }

      @Override
      public Delete setKey(String key) {
        return (Delete) super.setKey(key);
      }

      @Override
      public Delete setOauthToken(String oauthToken) {
        return (Delete) super.setOauthToken(oauthToken);
      }

      @Override
      public Delete setPrettyPrint(Boolean prettyPrint) {
        return (Delete) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Delete setQuotaUser(String quotaUser) {
        return (Delete) super.setQuotaUser(quotaUser);
      }

      @Override
      public Delete setUserIp(String userIp) {
        return (Delete) super.setUserIp(userIp);
      }

      /** The ID of the community whose message will be moved to the trash folder. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose message will be moved to the trash folder.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose message will be moved to the trash folder. */
      public Delete setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the topic whose message will be moved to the trash folder. */
      @com.google.api.client.util.Key
      private Long topicId;

      /** The ID of the topic whose message will be moved to the trash folder.
       */
      public Long getTopicId() {
        return topicId;
      }

      /** The ID of the topic whose message will be moved to the trash folder. */
      public Delete setTopicId(Long topicId) {
        this.topicId = topicId;
        return this;
      }

      /** The ID of the message to be moved to the trash folder. */
      @com.google.api.client.util.Key
      private Long messageId;

      /** The ID of the message to be moved to the trash folder.
       */
      public Long getMessageId() {
        return messageId;
      }

      /** The ID of the message to be moved to the trash folder. */
      public Delete setMessageId(Long messageId) {
        this.messageId = messageId;
        return this;
      }

    }
    /**
     * Adds a message to a given community topic.
     *
     * Create a request for the method "communityMessages.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community the message should be added to.
     * @param topicId The ID of the topic the message should be added to.
     * @param content the {@link com.google.api.services.orkut.model.CommunityMessage}
     * @return the request
     */
    public Insert insert(Integer communityId, Long topicId, com.google.api.services.orkut.model.CommunityMessage content) throws java.io.IOException {
      Insert result = new Insert(communityId, topicId, content);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.CommunityMessage> {

      private static final String REST_PATH = "communities/{communityId}/topics/{topicId}/messages";

      /**
       * Adds a message to a given community topic.
       *
       * Create a request for the method "communityMessages.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community the message should be added to.
       * @param topicId The ID of the topic the message should be added to.
       * @param content the {@link com.google.api.services.orkut.model.CommunityMessage}
       * @since 1.13
       */
      protected Insert(Integer communityId, Long topicId, com.google.api.services.orkut.model.CommunityMessage content) {
        super(Orkut.this, "POST", REST_PATH, content, com.google.api.services.orkut.model.CommunityMessage.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.topicId = Preconditions.checkNotNull(topicId, "Required parameter topicId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The ID of the community the message should be added to. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community the message should be added to.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community the message should be added to. */
      public Insert setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the topic the message should be added to. */
      @com.google.api.client.util.Key
      private Long topicId;

      /** The ID of the topic the message should be added to.
       */
      public Long getTopicId() {
        return topicId;
      }

      /** The ID of the topic the message should be added to. */
      public Insert setTopicId(Long topicId) {
        this.topicId = topicId;
        return this;
      }

    }
    /**
     * Retrieves the messages of a topic of a community.
     *
     * Create a request for the method "communityMessages.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community which messages will be listed.
     * @param topicId The ID of the topic which messages will be listed.
     * @return the request
     */
    public List list(Integer communityId, Long topicId) throws java.io.IOException {
      List result = new List(communityId, topicId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommunityMessageList> {

      private static final String REST_PATH = "communities/{communityId}/topics/{topicId}/messages";

      /**
       * Retrieves the messages of a topic of a community.
       *
       * Create a request for the method "communityMessages.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community which messages will be listed.
       * @param topicId The ID of the topic which messages will be listed.
       * @since 1.13
       */
      protected List(Integer communityId, Long topicId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityMessageList.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.topicId = Preconditions.checkNotNull(topicId, "Required parameter topicId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the community which messages will be listed. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community which messages will be listed.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community which messages will be listed. */
      public List setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the topic which messages will be listed. */
      @com.google.api.client.util.Key
      private Long topicId;

      /** The ID of the topic which messages will be listed.
       */
      public Long getTopicId() {
        return topicId;
      }

      /** The ID of the topic which messages will be listed. */
      public List setTopicId(Long topicId) {
        this.topicId = topicId;
        return this;
      }

      /** A continuation token that allows pagination. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token that allows pagination.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** A continuation token that allows pagination. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The maximum number of messages to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of messages to include in the response.

     [minimum: 1] [maximum: 100]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of messages to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityPollComments collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityPollComments.List request = orkut.communityPollComments().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityPollComments communityPollComments() {
    return new CommunityPollComments();
  }

  /**
   * The "communityPollComments" collection of methods.
   */
  public class CommunityPollComments {

    /**
     * Adds a comment on a community poll.
     *
     * Create a request for the method "communityPollComments.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose poll is being commented.
     * @param pollId The ID of the poll being commented.
     * @param content the {@link com.google.api.services.orkut.model.CommunityPollComment}
     * @return the request
     */
    public Insert insert(Integer communityId, String pollId, com.google.api.services.orkut.model.CommunityPollComment content) throws java.io.IOException {
      Insert result = new Insert(communityId, pollId, content);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.CommunityPollComment> {

      private static final String REST_PATH = "communities/{communityId}/polls/{pollId}/comments";

      /**
       * Adds a comment on a community poll.
       *
       * Create a request for the method "communityPollComments.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose poll is being commented.
       * @param pollId The ID of the poll being commented.
       * @param content the {@link com.google.api.services.orkut.model.CommunityPollComment}
       * @since 1.13
       */
      protected Insert(Integer communityId, String pollId, com.google.api.services.orkut.model.CommunityPollComment content) {
        super(Orkut.this, "POST", REST_PATH, content, com.google.api.services.orkut.model.CommunityPollComment.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.pollId = Preconditions.checkNotNull(pollId, "Required parameter pollId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The ID of the community whose poll is being commented. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose poll is being commented.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose poll is being commented. */
      public Insert setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the poll being commented. */
      @com.google.api.client.util.Key
      private String pollId;

      /** The ID of the poll being commented.
       */
      public String getPollId() {
        return pollId;
      }

      /** The ID of the poll being commented. */
      public Insert setPollId(String pollId) {
        this.pollId = pollId;
        return this;
      }

    }
    /**
     * Retrieves the comments of a community poll.
     *
     * Create a request for the method "communityPollComments.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose poll is having its comments listed.
     * @param pollId The ID of the community whose polls will be listed.
     * @return the request
     */
    public List list(Integer communityId, String pollId) throws java.io.IOException {
      List result = new List(communityId, pollId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommunityPollCommentList> {

      private static final String REST_PATH = "communities/{communityId}/polls/{pollId}/comments";

      /**
       * Retrieves the comments of a community poll.
       *
       * Create a request for the method "communityPollComments.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose poll is having its comments listed.
       * @param pollId The ID of the community whose polls will be listed.
       * @since 1.13
       */
      protected List(Integer communityId, String pollId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityPollCommentList.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.pollId = Preconditions.checkNotNull(pollId, "Required parameter pollId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the community whose poll is having its comments listed. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose poll is having its comments listed.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose poll is having its comments listed. */
      public List setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the community whose polls will be listed. */
      @com.google.api.client.util.Key
      private String pollId;

      /** The ID of the community whose polls will be listed.
       */
      public String getPollId() {
        return pollId;
      }

      /** The ID of the community whose polls will be listed. */
      public List setPollId(String pollId) {
        this.pollId = pollId;
        return this;
      }

      /** A continuation token that allows pagination. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token that allows pagination.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** A continuation token that allows pagination. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The maximum number of comments to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of comments to include in the response.

     [minimum: 1]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of comments to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityPollVotes collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityPollVotes.List request = orkut.communityPollVotes().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityPollVotes communityPollVotes() {
    return new CommunityPollVotes();
  }

  /**
   * The "communityPollVotes" collection of methods.
   */
  public class CommunityPollVotes {

    /**
     * Votes on a community poll.
     *
     * Create a request for the method "communityPollVotes.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose poll is being voted.
     * @param pollId The ID of the poll being voted.
     * @param content the {@link com.google.api.services.orkut.model.CommunityPollVote}
     * @return the request
     */
    public Insert insert(Integer communityId, String pollId, com.google.api.services.orkut.model.CommunityPollVote content) throws java.io.IOException {
      Insert result = new Insert(communityId, pollId, content);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.CommunityPollVote> {

      private static final String REST_PATH = "communities/{communityId}/polls/{pollId}/votes";

      /**
       * Votes on a community poll.
       *
       * Create a request for the method "communityPollVotes.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose poll is being voted.
       * @param pollId The ID of the poll being voted.
       * @param content the {@link com.google.api.services.orkut.model.CommunityPollVote}
       * @since 1.13
       */
      protected Insert(Integer communityId, String pollId, com.google.api.services.orkut.model.CommunityPollVote content) {
        super(Orkut.this, "POST", REST_PATH, content, com.google.api.services.orkut.model.CommunityPollVote.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.pollId = Preconditions.checkNotNull(pollId, "Required parameter pollId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The ID of the community whose poll is being voted. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose poll is being voted.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose poll is being voted. */
      public Insert setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the poll being voted. */
      @com.google.api.client.util.Key
      private String pollId;

      /** The ID of the poll being voted.
       */
      public String getPollId() {
        return pollId;
      }

      /** The ID of the poll being voted. */
      public Insert setPollId(String pollId) {
        this.pollId = pollId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityPolls collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityPolls.List request = orkut.communityPolls().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityPolls communityPolls() {
    return new CommunityPolls();
  }

  /**
   * The "communityPolls" collection of methods.
   */
  public class CommunityPolls {

    /**
     * Retrieves one specific poll of a community.
     *
     * Create a request for the method "communityPolls.get".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community for whose poll will be retrieved.
     * @param pollId The ID of the poll to get.
     * @return the request
     */
    public Get get(Integer communityId, String pollId) throws java.io.IOException {
      Get result = new Get(communityId, pollId);
      initialize(result);
      return result;
    }

    public class Get extends OrkutRequest<com.google.api.services.orkut.model.CommunityPoll> {

      private static final String REST_PATH = "communities/{communityId}/polls/{pollId}";

      /**
       * Retrieves one specific poll of a community.
       *
       * Create a request for the method "communityPolls.get".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community for whose poll will be retrieved.
       * @param pollId The ID of the poll to get.
       * @since 1.13
       */
      protected Get(Integer communityId, String pollId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityPoll.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.pollId = Preconditions.checkNotNull(pollId, "Required parameter pollId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The ID of the community for whose poll will be retrieved. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community for whose poll will be retrieved.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community for whose poll will be retrieved. */
      public Get setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the poll to get. */
      @com.google.api.client.util.Key
      private String pollId;

      /** The ID of the poll to get.
       */
      public String getPollId() {
        return pollId;
      }

      /** The ID of the poll to get. */
      public Get setPollId(String pollId) {
        this.pollId = pollId;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public Get setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }
    /**
     * Retrieves the polls of a community.
     *
     * Create a request for the method "communityPolls.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community which polls will be listed.
     * @return the request
     */
    public List list(Integer communityId) throws java.io.IOException {
      List result = new List(communityId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommunityPollList> {

      private static final String REST_PATH = "communities/{communityId}/polls";

      /**
       * Retrieves the polls of a community.
       *
       * Create a request for the method "communityPolls.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community which polls will be listed.
       * @since 1.13
       */
      protected List(Integer communityId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityPollList.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the community which polls will be listed. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community which polls will be listed.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community which polls will be listed. */
      public List setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** A continuation token that allows pagination. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token that allows pagination.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** A continuation token that allows pagination. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The maximum number of polls to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of polls to include in the response.

     [minimum: 1]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of polls to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityRelated collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityRelated.List request = orkut.communityRelated().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityRelated communityRelated() {
    return new CommunityRelated();
  }

  /**
   * The "communityRelated" collection of methods.
   */
  public class CommunityRelated {

    /**
     * Retrieves the communities related to another one.
     *
     * Create a request for the method "communityRelated.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose related communities will be listed.
     * @return the request
     */
    public List list(Integer communityId) throws java.io.IOException {
      List result = new List(communityId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommunityList> {

      private static final String REST_PATH = "communities/{communityId}/related";

      /**
       * Retrieves the communities related to another one.
       *
       * Create a request for the method "communityRelated.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose related communities will be listed.
       * @since 1.13
       */
      protected List(Integer communityId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityList.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the community whose related communities will be listed. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose related communities will be listed.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose related communities will be listed. */
      public List setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the CommunityTopics collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.CommunityTopics.List request = orkut.communityTopics().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public CommunityTopics communityTopics() {
    return new CommunityTopics();
  }

  /**
   * The "communityTopics" collection of methods.
   */
  public class CommunityTopics {

    /**
     * Moves a topic of the community to the trash folder.
     *
     * Create a request for the method "communityTopics.delete".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Delete#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose topic will be moved to the trash folder.
     * @param topicId The ID of the topic to be moved to the trash folder.
     * @return the request
     */
    public Delete delete(Integer communityId, Long topicId) throws java.io.IOException {
      Delete result = new Delete(communityId, topicId);
      initialize(result);
      return result;
    }

    public class Delete extends OrkutRequest<Void> {

      private static final String REST_PATH = "communities/{communityId}/topics/{topicId}";

      /**
       * Moves a topic of the community to the trash folder.
       *
       * Create a request for the method "communityTopics.delete".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Delete#execute()} method to invoke the remote operation. <p> {@link
       * Delete#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose topic will be moved to the trash folder.
       * @param topicId The ID of the topic to be moved to the trash folder.
       * @since 1.13
       */
      protected Delete(Integer communityId, Long topicId) {
        super(Orkut.this, "DELETE", REST_PATH, null, Void.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.topicId = Preconditions.checkNotNull(topicId, "Required parameter topicId must be specified.");
      }

      @Override
      public Delete setAlt(String alt) {
        return (Delete) super.setAlt(alt);
      }

      @Override
      public Delete setFields(String fields) {
        return (Delete) super.setFields(fields);
      }

      @Override
      public Delete setKey(String key) {
        return (Delete) super.setKey(key);
      }

      @Override
      public Delete setOauthToken(String oauthToken) {
        return (Delete) super.setOauthToken(oauthToken);
      }

      @Override
      public Delete setPrettyPrint(Boolean prettyPrint) {
        return (Delete) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Delete setQuotaUser(String quotaUser) {
        return (Delete) super.setQuotaUser(quotaUser);
      }

      @Override
      public Delete setUserIp(String userIp) {
        return (Delete) super.setUserIp(userIp);
      }

      /** The ID of the community whose topic will be moved to the trash folder. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose topic will be moved to the trash folder.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose topic will be moved to the trash folder. */
      public Delete setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the topic to be moved to the trash folder. */
      @com.google.api.client.util.Key
      private Long topicId;

      /** The ID of the topic to be moved to the trash folder.
       */
      public Long getTopicId() {
        return topicId;
      }

      /** The ID of the topic to be moved to the trash folder. */
      public Delete setTopicId(Long topicId) {
        this.topicId = topicId;
        return this;
      }

    }
    /**
     * Retrieves a topic of a community.
     *
     * Create a request for the method "communityTopics.get".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Get#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community whose topic will be retrieved.
     * @param topicId The ID of the topic to get.
     * @return the request
     */
    public Get get(Integer communityId, Long topicId) throws java.io.IOException {
      Get result = new Get(communityId, topicId);
      initialize(result);
      return result;
    }

    public class Get extends OrkutRequest<com.google.api.services.orkut.model.CommunityTopic> {

      private static final String REST_PATH = "communities/{communityId}/topics/{topicId}";

      /**
       * Retrieves a topic of a community.
       *
       * Create a request for the method "communityTopics.get".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Get#execute()} method to invoke the remote operation. <p> {@link
       * Get#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community whose topic will be retrieved.
       * @param topicId The ID of the topic to get.
       * @since 1.13
       */
      protected Get(Integer communityId, Long topicId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityTopic.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
        this.topicId = Preconditions.checkNotNull(topicId, "Required parameter topicId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public Get setAlt(String alt) {
        return (Get) super.setAlt(alt);
      }

      @Override
      public Get setFields(String fields) {
        return (Get) super.setFields(fields);
      }

      @Override
      public Get setKey(String key) {
        return (Get) super.setKey(key);
      }

      @Override
      public Get setOauthToken(String oauthToken) {
        return (Get) super.setOauthToken(oauthToken);
      }

      @Override
      public Get setPrettyPrint(Boolean prettyPrint) {
        return (Get) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Get setQuotaUser(String quotaUser) {
        return (Get) super.setQuotaUser(quotaUser);
      }

      @Override
      public Get setUserIp(String userIp) {
        return (Get) super.setUserIp(userIp);
      }

      /** The ID of the community whose topic will be retrieved. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community whose topic will be retrieved.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community whose topic will be retrieved. */
      public Get setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** The ID of the topic to get. */
      @com.google.api.client.util.Key
      private Long topicId;

      /** The ID of the topic to get.
       */
      public Long getTopicId() {
        return topicId;
      }

      /** The ID of the topic to get. */
      public Get setTopicId(Long topicId) {
        this.topicId = topicId;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public Get setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }
    /**
     * Adds a topic to a given community.
     *
     * Create a request for the method "communityTopics.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community the topic should be added to.
     * @param content the {@link com.google.api.services.orkut.model.CommunityTopic}
     * @return the request
     */
    public Insert insert(Integer communityId, com.google.api.services.orkut.model.CommunityTopic content) throws java.io.IOException {
      Insert result = new Insert(communityId, content);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.CommunityTopic> {

      private static final String REST_PATH = "communities/{communityId}/topics";

      /**
       * Adds a topic to a given community.
       *
       * Create a request for the method "communityTopics.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community the topic should be added to.
       * @param content the {@link com.google.api.services.orkut.model.CommunityTopic}
       * @since 1.13
       */
      protected Insert(Integer communityId, com.google.api.services.orkut.model.CommunityTopic content) {
        super(Orkut.this, "POST", REST_PATH, content, com.google.api.services.orkut.model.CommunityTopic.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

      /** The ID of the community the topic should be added to. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community the topic should be added to.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community the topic should be added to. */
      public Insert setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** Whether this topic is a shout. */
      @com.google.api.client.util.Key
      private Boolean isShout;

      /** Whether this topic is a shout.
       */
      public Boolean getIsShout() {
        return isShout;
      }

      /** Whether this topic is a shout. */
      public Insert setIsShout(Boolean isShout) {
        this.isShout = isShout;
        return this;
      }

    }
    /**
     * Retrieves the topics of a community.
     *
     * Create a request for the method "communityTopics.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param communityId The ID of the community which topics will be listed.
     * @return the request
     */
    public List list(Integer communityId) throws java.io.IOException {
      List result = new List(communityId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.CommunityTopicList> {

      private static final String REST_PATH = "communities/{communityId}/topics";

      /**
       * Retrieves the topics of a community.
       *
       * Create a request for the method "communityTopics.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param communityId The ID of the community which topics will be listed.
       * @since 1.13
       */
      protected List(Integer communityId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.CommunityTopicList.class);
        this.communityId = Preconditions.checkNotNull(communityId, "Required parameter communityId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the community which topics will be listed. */
      @com.google.api.client.util.Key
      private Integer communityId;

      /** The ID of the community which topics will be listed.
       */
      public Integer getCommunityId() {
        return communityId;
      }

      /** The ID of the community which topics will be listed. */
      public List setCommunityId(Integer communityId) {
        this.communityId = communityId;
        return this;
      }

      /** A continuation token that allows pagination. */
      @com.google.api.client.util.Key
      private String pageToken;

      /** A continuation token that allows pagination.
       */
      public String getPageToken() {
        return pageToken;
      }

      /** A continuation token that allows pagination. */
      public List setPageToken(String pageToken) {
        this.pageToken = pageToken;
        return this;
      }

      /** The maximum number of topics to include in the response. */
      @com.google.api.client.util.Key
      private Long maxResults;

      /** The maximum number of topics to include in the response.

     [minimum: 1] [maximum: 100]
       */
      public Long getMaxResults() {
        return maxResults;
      }

      /** The maximum number of topics to include in the response. */
      public List setMaxResults(Long maxResults) {
        this.maxResults = maxResults;
        return this;
      }

      /** Specifies the interface language (host language) of your user interface. */
      @com.google.api.client.util.Key
      private String hl;

      /** Specifies the interface language (host language) of your user interface.
       */
      public String getHl() {
        return hl;
      }

      /** Specifies the interface language (host language) of your user interface. */
      public List setHl(String hl) {
        this.hl = hl;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Counters collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.Counters.List request = orkut.counters().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Counters counters() {
    return new Counters();
  }

  /**
   * The "counters" collection of methods.
   */
  public class Counters {

    /**
     * Retrieves the counters of a user.
     *
     * Create a request for the method "counters.list".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link List#execute()} method to invoke the remote operation.
     *
     * @param userId The ID of the user whose counters will be listed. Can be me to refer to caller.
     * @return the request
     */
    public List list(String userId) throws java.io.IOException {
      List result = new List(userId);
      initialize(result);
      return result;
    }

    public class List extends OrkutRequest<com.google.api.services.orkut.model.Counters> {

      private static final String REST_PATH = "people/{userId}/counters";

      /**
       * Retrieves the counters of a user.
       *
       * Create a request for the method "counters.list".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link List#execute()} method to invoke the remote operation. <p> {@link
       * List#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param userId The ID of the user whose counters will be listed. Can be me to refer to caller.
       * @since 1.13
       */
      protected List(String userId) {
        super(Orkut.this, "GET", REST_PATH, null, com.google.api.services.orkut.model.Counters.class);
        this.userId = Preconditions.checkNotNull(userId, "Required parameter userId must be specified.");
      }

      @Override
      public com.google.api.client.http.HttpResponse executeUsingHead() throws java.io.IOException {
        return super.executeUsingHead();
      }

      @Override
      public com.google.api.client.http.HttpRequest buildHttpRequestUsingHead() throws java.io.IOException {
        return super.buildHttpRequestUsingHead();
      }

      @Override
      public List setAlt(String alt) {
        return (List) super.setAlt(alt);
      }

      @Override
      public List setFields(String fields) {
        return (List) super.setFields(fields);
      }

      @Override
      public List setKey(String key) {
        return (List) super.setKey(key);
      }

      @Override
      public List setOauthToken(String oauthToken) {
        return (List) super.setOauthToken(oauthToken);
      }

      @Override
      public List setPrettyPrint(Boolean prettyPrint) {
        return (List) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public List setQuotaUser(String quotaUser) {
        return (List) super.setQuotaUser(quotaUser);
      }

      @Override
      public List setUserIp(String userIp) {
        return (List) super.setUserIp(userIp);
      }

      /** The ID of the user whose counters will be listed. Can be me to refer to caller. */
      @com.google.api.client.util.Key
      private String userId;

      /** The ID of the user whose counters will be listed. Can be me to refer to caller.
       */
      public String getUserId() {
        return userId;
      }

      /** The ID of the user whose counters will be listed. Can be me to refer to caller. */
      public List setUserId(String userId) {
        this.userId = userId;
        return this;
      }

    }

  }

  /**
   * An accessor for creating requests from the Scraps collection.
   *
   * <p>The typical use is:</p>
   * <pre>
   *   {@code Orkut orkut = new Orkut(...);}
   *   {@code Orkut.Scraps.List request = orkut.scraps().list(parameters ...)}
   * </pre>
   *
   * @return the resource collection
   */
  public Scraps scraps() {
    return new Scraps();
  }

  /**
   * The "scraps" collection of methods.
   */
  public class Scraps {

    /**
     * Creates a new scrap.
     *
     * Create a request for the method "scraps.insert".
     *
     * This request holds the parameters needed by the the orkut server.  After setting any optional
     * parameters, call the {@link Insert#execute()} method to invoke the remote operation.
     *
     * @param content the {@link com.google.api.services.orkut.model.Activity}
     * @return the request
     */
    public Insert insert(com.google.api.services.orkut.model.Activity content) throws java.io.IOException {
      Insert result = new Insert(content);
      initialize(result);
      return result;
    }

    public class Insert extends OrkutRequest<com.google.api.services.orkut.model.Activity> {

      private static final String REST_PATH = "activities/scraps";

      /**
       * Creates a new scrap.
       *
       * Create a request for the method "scraps.insert".
       *
       * This request holds the parameters needed by the the orkut server.  After setting any optional
       * parameters, call the {@link Insert#execute()} method to invoke the remote operation. <p> {@link
       * Insert#initialize(AbstractGoogleClientRequest)} must be called to initialize this instance
       * immediately after invoking the constructor. </p>
       *
       * @param content the {@link com.google.api.services.orkut.model.Activity}
       * @since 1.13
       */
      protected Insert(com.google.api.services.orkut.model.Activity content) {
        super(Orkut.this, "POST", REST_PATH, content, com.google.api.services.orkut.model.Activity.class);
      }

      @Override
      public Insert setAlt(String alt) {
        return (Insert) super.setAlt(alt);
      }

      @Override
      public Insert setFields(String fields) {
        return (Insert) super.setFields(fields);
      }

      @Override
      public Insert setKey(String key) {
        return (Insert) super.setKey(key);
      }

      @Override
      public Insert setOauthToken(String oauthToken) {
        return (Insert) super.setOauthToken(oauthToken);
      }

      @Override
      public Insert setPrettyPrint(Boolean prettyPrint) {
        return (Insert) super.setPrettyPrint(prettyPrint);
      }

      @Override
      public Insert setQuotaUser(String quotaUser) {
        return (Insert) super.setQuotaUser(quotaUser);
      }

      @Override
      public Insert setUserIp(String userIp) {
        return (Insert) super.setUserIp(userIp);
      }

    }

  }

  /**
   * Builder for {@link Orkut}.
   *
   * <p>
   * Implementation is not thread-safe.
   * </p>
   *
   * @since 1.3.0
   */
  public static final class Builder extends AbstractGoogleJsonClient.Builder {

    /**
     * Returns an instance of a new builder.
     *
     * @param transport HTTP transport
     * @param jsonFactory JSON factory
     * @param httpRequestInitializer HTTP request initializer or {@code null} for none
     * @since 1.7
     */
    public Builder(HttpTransport transport, JsonFactory jsonFactory,
        HttpRequestInitializer httpRequestInitializer) {
      super(
          transport,
          jsonFactory,
          DEFAULT_ROOT_URL,
          DEFAULT_SERVICE_PATH,
          httpRequestInitializer,
          false);
    }

    /** Builds a new instance of {@link Orkut}. */
    @Override
    public Orkut build() {
      return new Orkut(getTransport(),
          getHttpRequestInitializer(),
          getRootUrl(),
          getServicePath(),
          getObjectParser(),
          getGoogleClientRequestInitializer(),
          getApplicationName(),
          getSuppressPatternChecks());
    }

    @Override
    public Builder setRootUrl(String rootUrl) {
      return (Builder) super.setRootUrl(rootUrl);
    }

    @Override
    public Builder setServicePath(String servicePath) {
      return (Builder) super.setServicePath(servicePath);
    }

    @Override
    public Builder setHttpRequestInitializer(HttpRequestInitializer httpRequestInitializer) {
      return (Builder) super.setHttpRequestInitializer(httpRequestInitializer);
    }

    @Override
    public Builder setApplicationName(String applicationName) {
      return (Builder) super.setApplicationName(applicationName);
    }

    @Override
    public Builder setSuppressPatternChecks(boolean suppressPatternChecks) {
      return (Builder) super.setSuppressPatternChecks(suppressPatternChecks);
    }

    /**
     * Set the {@link OrkutRequestInitializer}.
     *
     * @since 1.12
     */
    public Builder setOrkutRequestInitializer(
        OrkutRequestInitializer orkutRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(orkutRequestInitializer);
    }

    @Override
    public Builder setGoogleClientRequestInitializer(
        GoogleClientRequestInitializer googleClientRequestInitializer) {
      return (Builder) super.setGoogleClientRequestInitializer(googleClientRequestInitializer);
    }
  }
}
